diff -urN Android_6.0.1_r11/frameworks/base/include/androidfw/ABCManager.h SAMD_6.0.1_r11_20170930/frameworks/base/include/androidfw/ABCManager.h
--- Android_6.0.1_r11/frameworks/base/include/androidfw/ABCManager.h	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/include/androidfw/ABCManager.h	2016-11-01 17:36:40.402408000 +0900
@@ -0,0 +1,399 @@
+/*
+ * Copyright (C) 2006 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+//
+// Asset management class.  AssetManager objects are thread-safe.
+//
+#ifndef __LIBS_ABCMANAGER_H
+#define __LIBS_ABCMANAGER_H
+
+#include <androidfw/Asset.h>
+#include <androidfw/AssetDir.h>
+#include <androidfw/ZipFileRO.h>
+#include <utils/KeyedVector.h>
+#include <utils/SortedVector.h>
+#include <utils/String16.h>
+#include <utils/String8.h>
+#include <utils/threads.h>
+#include <utils/Vector.h>
+
+/*
+ * Native-app access is via the opaque typedef struct AAssetManager in the C namespace.
+ */
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+struct AABCManager { };
+
+#ifdef __cplusplus
+};
+#endif
+
+
+/*
+ * Now the proper C++ android-namespace definitions
+ */
+
+namespace android {
+
+class Asset;        // fwd decl for things that include Asset.h first
+class ResTable;
+struct ResTable_config;
+
+/*
+ * Every application that uses assets needs one instance of this.  A
+ * single instance may be shared across multiple threads, and a single
+ * thread may have more than one instance (the latter is discouraged).
+ *
+ * The purpose of the AssetManager is to create Asset objects.  To do
+ * this efficiently it may cache information about the locations of
+ * files it has seen.  This can be controlled with the "cacheMode"
+ * argument.
+ *
+ * The asset hierarchy may be examined like a filesystem, using
+ * AssetDir objects to peruse a single directory.
+ */
+class ABCManager : public AABCManager {
+public:
+    static const char* RESOURCES_FILENAME;
+    static const char* IDMAP_BIN;
+    static const char* OVERLAY_DIR;
+    static const char* TARGET_PACKAGE_NAME;
+    static const char* TARGET_APK_PATH;
+    static const char* IDMAP_DIR;
+
+    typedef enum CacheMode {
+        CACHE_UNKNOWN = 0,
+        CACHE_OFF,          // don't try to cache file locations
+        CACHE_DEFER,        // construct cache as pieces are needed
+        //CACHE_SCAN,         // scan full(!) asset hierarchy at init() time
+    } CacheMode;
+
+    ABCManager(CacheMode cacheMode = CACHE_OFF);
+    virtual ~ABCManager(void);
+
+    int aapt(const char* res_path, const char* manifest_path, const char* output_apk);
+
+    static int32_t getGlobalCount();
+    
+    /*                                                                       
+     * Add a new source for assets.  This can be called multiple times to
+     * look in multiple places for assets.  It can be either a directory (for
+     * finding assets as raw files on the disk) or a ZIP file.  This newly
+     * added asset path will be examined first when searching for assets,
+     * before any that were previously added.
+     *
+     * Returns "true" on success, "false" on failure.  If 'cookie' is non-NULL,
+     * then on success, *cookie is set to the value corresponding to the
+     * newly-added asset source.
+     */
+    bool addAssetPath(const String8& path, int32_t* cookie);
+    bool addOverlayPath(const String8& path, int32_t* cookie);
+
+    /*                                                                       
+     * Convenience for adding the standard system assets.  Uses the
+     * ANDROID_ROOT environment variable to find them.
+     */
+    bool addDefaultAssets();
+
+    bool addABCAssets();
+
+    /*                                                                       
+     * Iterate over the asset paths in this manager.  (Previously
+     * added via addAssetPath() and addDefaultAssets().)  On first call,
+     * 'cookie' must be 0, resulting in the first cookie being returned.
+     * Each next cookie will be returned there-after, until -1 indicating
+     * the end has been reached.
+     */
+    int32_t nextAssetPath(const int32_t cookie) const;
+
+    /*                                                                       
+     * Return an asset path in the manager.  'which' must be between 0 and
+     * countAssetPaths().
+     */
+    String8 getAssetPath(const int32_t cookie) const;
+
+    /*
+     * Set the current locale and vendor.  The locale can change during
+     * the lifetime of an AssetManager if the user updates the device's
+     * language setting.  The vendor is less likely to change.
+     *
+     * Pass in NULL to indicate no preference.
+     */
+    void setLocale(const char* locale);
+    void setVendor(const char* vendor);
+
+    /*
+     * Choose screen orientation for resources values returned.
+     */
+    void setConfiguration(const ResTable_config& config, const char* locale = NULL);
+
+    void getConfiguration(ResTable_config* outConfig) const;
+
+    typedef Asset::AccessMode AccessMode;       // typing shortcut
+
+    /*
+     * Open an asset.
+     *
+     * This will search through locale-specific and vendor-specific
+     * directories and packages to find the file.
+     *
+     * The object returned does not depend on the AssetManager.  It should
+     * be freed by calling Asset::close().
+     */
+    Asset* open(const char* fileName, AccessMode mode);
+
+    /*
+     * Open a non-asset file as an asset.
+     *
+     * This is for opening files that are included in an asset package
+     * but aren't assets.  These sit outside the usual "locale/vendor"
+     * path hierarchy, and will not be seen by "AssetDir" or included
+     * in our filename cache.
+     */
+    Asset* openNonAsset(const char* fileName, AccessMode mode, int32_t* outCookie = NULL);
+
+    /*
+     * Explicit non-asset file.  The file explicitly named by the cookie (the
+     * resource set to look in) and fileName will be opened and returned.
+     */
+    Asset* openNonAsset(const int32_t cookie, const char* fileName, AccessMode mode);
+
+    /*
+     * Open a directory within the asset hierarchy.
+     *
+     * The contents of the directory are an amalgam of vendor-specific,
+     * locale-specific, and generic assets stored loosely or in asset
+     * packages.  Depending on the cache setting and previous accesses,
+     * this call may incur significant disk overhead.
+     *
+     * To open the top-level directory, pass in "".
+     */
+    AssetDir* openDir(const char* dirName);
+
+    /*
+     * Open a directory within a particular path of the asset manager.
+     *
+     * The contents of the directory are an amalgam of vendor-specific,
+     * locale-specific, and generic assets stored loosely or in asset
+     * packages.  Depending on the cache setting and previous accesses,
+     * this call may incur significant disk overhead.
+     *
+     * To open the top-level directory, pass in "".
+     */
+    AssetDir* openNonAssetDir(const int32_t cookie, const char* dirName);
+
+    /*
+     * Get the type of a file in the asset hierarchy.  They will either
+     * be "regular" or "directory".  [Currently only works for "regular".]
+     *
+     * Can also be used as a quick test for existence of a file.
+     */
+    FileType getFileType(const char* fileName);
+
+    /*                                                                       
+     * Return the complete resource table to find things in the package.
+     */
+    const ResTable& getResources(bool required = true) const;
+
+    /*
+     * Discard cached filename information.  This only needs to be called
+     * if somebody has updated the set of "loose" files, and we want to
+     * discard our cached notion of what's where.
+     */
+    void purge(void) { purgeFileNameCacheLocked(); }
+
+    /*
+     * Return true if the files this AssetManager references are all
+     * up-to-date (have not been changed since it was created).  If false
+     * is returned, you will need to create a new AssetManager to get
+     * the current data.
+     */
+    bool isUpToDate();
+    
+    /**
+     * Get the known locales for this asset manager object.
+     */
+    void getLocales(Vector<String8>* locales) const;
+
+    /**
+     * Generate idmap data to translate resources IDs between a package and a
+     * corresponding overlay package.
+     */
+    bool createIdmap(const char* targetApkPath, const char* overlayApkPath,
+        uint32_t targetCrc, uint32_t overlayCrc, uint32_t** outData, size_t* outSize);
+
+private:
+    struct asset_path
+    {
+        asset_path() : path(""), type(kFileTypeRegular), idmap(""), isSystemOverlay(false) {}
+        String8 path;
+        FileType type;
+        String8 idmap;
+        bool isSystemOverlay;
+    };
+
+    Asset* openInPathLocked(const char* fileName, AccessMode mode,
+        const asset_path& path);
+    Asset* openNonAssetInPathLocked(const char* fileName, AccessMode mode,
+        const asset_path& path);
+    Asset* openInLocaleVendorLocked(const char* fileName, AccessMode mode,
+        const asset_path& path, const char* locale, const char* vendor);
+    String8 createPathNameLocked(const asset_path& path, const char* locale,
+        const char* vendor);
+    String8 createPathNameLocked(const asset_path& path, const char* rootDir);
+    String8 createZipSourceNameLocked(const String8& zipFileName,
+        const String8& dirName, const String8& fileName);
+
+    ZipFileRO* getZipFileLocked(const asset_path& path);
+    Asset* openAssetFromFileLocked(const String8& fileName, AccessMode mode);
+    Asset* openAssetFromZipLocked(const ZipFileRO* pZipFile,
+        const ZipEntryRO entry, AccessMode mode, const String8& entryName);
+
+    bool scanAndMergeDirLocked(SortedVector<AssetDir::FileInfo>* pMergedInfo,
+        const asset_path& path, const char* rootDir, const char* dirName);
+    SortedVector<AssetDir::FileInfo>* scanDirLocked(const String8& path);
+    bool scanAndMergeZipLocked(SortedVector<AssetDir::FileInfo>* pMergedInfo,
+        const asset_path& path, const char* rootDir, const char* dirName);
+    void mergeInfoLocked(SortedVector<AssetDir::FileInfo>* pMergedInfo,
+        const SortedVector<AssetDir::FileInfo>* pContents);
+
+    void loadFileNameCacheLocked(void);
+    void fncScanLocked(SortedVector<AssetDir::FileInfo>* pMergedInfo,
+        const char* dirName);
+    bool fncScanAndMergeDirLocked(
+        SortedVector<AssetDir::FileInfo>* pMergedInfo,
+        const asset_path& path, const char* locale, const char* vendor,
+        const char* dirName);
+    void purgeFileNameCacheLocked(void);
+
+    const ResTable* getResTable(bool required = true) const;
+    void setLocaleLocked(const char* locale);
+    void updateResourceParamsLocked() const;
+    bool appendPathToResTable(const asset_path& ap) const;
+
+    Asset* openIdmapLocked(const struct asset_path& ap) const;
+
+    void addSystemOverlays(const char* pathOverlaysList, const String8& targetPackagePath,
+            ResTable* sharedRes, size_t offset) const;
+
+    class SharedZip : public RefBase {
+    public:
+        static sp<SharedZip> get(const String8& path, bool createIfNotPresent = true);
+
+        ZipFileRO* getZip();
+
+        Asset* getResourceTableAsset();
+        Asset* setResourceTableAsset(Asset* asset);
+
+        ResTable* getResourceTable();
+        ResTable* setResourceTable(ResTable* res);
+        
+        bool isUpToDate();
+
+        void addOverlay(const asset_path& ap);
+        bool getOverlay(size_t idx, asset_path* out) const;
+        
+    protected:
+        ~SharedZip();
+
+    private:
+        SharedZip(const String8& path, time_t modWhen);
+        SharedZip(); // <-- not implemented
+
+        String8 mPath;
+        ZipFileRO* mZipFile;
+        time_t mModWhen;
+
+        Asset* mResourceTableAsset;
+        ResTable* mResourceTable;
+
+        Vector<asset_path> mOverlays;
+
+        static Mutex gLock;
+        static DefaultKeyedVector<String8, wp<SharedZip> > gOpen;
+    };
+
+    /*
+     * Manage a set of Zip files.  For each file we need a pointer to the
+     * ZipFile and a time_t with the file's modification date.
+     *
+     * We currently only have two zip files (current app, "common" app).
+     * (This was originally written for 8, based on app/locale/vendor.)
+     */
+    class ZipSet {
+    public:
+        ZipSet(void);
+        ~ZipSet(void);
+
+        /*
+         * Return a ZipFileRO structure for a ZipFileRO with the specified
+         * parameters.
+         */
+        ZipFileRO* getZip(const String8& path);
+
+        Asset* getZipResourceTableAsset(const String8& path);
+        Asset* setZipResourceTableAsset(const String8& path, Asset* asset);
+
+        ResTable* getZipResourceTable(const String8& path);
+        ResTable* setZipResourceTable(const String8& path, ResTable* res);
+
+        // generate path, e.g. "common/en-US-noogle.zip"
+        static String8 getPathName(const char* path);
+
+        bool isUpToDate();
+
+        void addOverlay(const String8& path, const asset_path& overlay);
+        bool getOverlay(const String8& path, size_t idx, asset_path* out) const;
+        
+    private:
+        void closeZip(int idx);
+
+        int getIndex(const String8& zip) const;
+        mutable Vector<String8> mZipPath;
+        mutable Vector<sp<SharedZip> > mZipFile;
+    };
+
+    // Protect all internal state.
+    mutable Mutex   mLock;
+
+    ZipSet          mZipSet;
+
+    Vector<asset_path> mAssetPaths;
+    char*           mLocale;
+    char*           mVendor;
+
+    mutable ResTable* mResources;
+    ResTable_config* mConfig;
+
+    /*
+     * Cached data for "loose" files.  This lets us avoid poking at the
+     * filesystem when searching for loose assets.  Each entry is the
+     * "extended partial" path, e.g. "default/default/foo/bar.txt".  The
+     * full set of files is present, including ".EXCLUDE" entries.
+     *
+     * We do not cache directory names.  We don't retain the ".gz",
+     * because to our clients "foo" and "foo.gz" both look like "foo".
+     */
+    CacheMode       mCacheMode;         // is the cache enabled?
+    bool            mCacheValid;        // clear when locale or vendor changes
+    SortedVector<AssetDir::FileInfo> mCache;
+};
+
+}; // namespace android
+
+#endif // __LIBS_ABCMANAGER_H
diff -urN Android_6.0.1_r11/frameworks/base/include/androidfw/AssetDir.h SAMD_6.0.1_r11_20170930/frameworks/base/include/androidfw/AssetDir.h
--- Android_6.0.1_r11/frameworks/base/include/androidfw/AssetDir.h	2017-09-27 02:07:54.223736042 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/include/androidfw/AssetDir.h	2016-11-01 17:36:40.402408000 +0900
@@ -70,6 +70,7 @@
     const AssetDir& operator=(const AssetDir& src);
 
     friend class AssetManager;
+    friend class ABCManager;
 
     /*
      * This holds information about files in the asset hierarchy.
diff -urN Android_6.0.1_r11/frameworks/base/include/androidfw/Asset.h SAMD_6.0.1_r11_20170930/frameworks/base/include/androidfw/Asset.h
--- Android_6.0.1_r11/frameworks/base/include/androidfw/Asset.h	2017-09-27 02:07:54.223736042 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/include/androidfw/Asset.h	2016-11-01 17:36:40.402408000 +0900
@@ -136,6 +136,7 @@
 
     /* AssetManager needs access to our "create" functions */
     friend class AssetManager;
+    friend class ABCManager;
 
     /*
      * Create the asset from a named file on disk.
diff -urN Android_6.0.1_r11/frameworks/base/include/android_runtime/android_util_ABCManager.h SAMD_6.0.1_r11_20170930/frameworks/base/include/android_runtime/android_util_ABCManager.h
--- Android_6.0.1_r11/frameworks/base/include/android_runtime/android_util_ABCManager.h	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/include/android_runtime/android_util_ABCManager.h	2016-11-01 17:36:40.402408000 +0900
@@ -0,0 +1,30 @@
+/*
+ * Copyright (C) 2008 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef android_util_ABCManager_H
+#define android_util_ABCManager_H
+
+#include <androidfw/ABCManager.h>
+
+#include "jni.h"
+
+namespace android {
+
+extern ABCManager* ABCManagerForJavaObject(JNIEnv* env, jobject ABCMgr);
+
+}
+
+#endif
diff -urN Android_6.0.1_r11/frameworks/base/libs/androidfw/Android.mk SAMD_6.0.1_r11_20170930/frameworks/base/libs/androidfw/Android.mk
--- Android_6.0.1_r11/frameworks/base/libs/androidfw/Android.mk	2017-09-27 02:07:54.239736042 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/libs/androidfw/Android.mk	2017-07-11 02:48:11.245245000 +0900
@@ -49,6 +49,7 @@
 LOCAL_SRC_FILES:= $(hostSources)
 LOCAL_C_INCLUDES := external/zlib
 
+
 include $(BUILD_HOST_STATIC_LIBRARY)
 
 
@@ -63,7 +64,7 @@
 LOCAL_SRC_FILES:= $(deviceSources)
 LOCAL_C_INCLUDES := \
     external/zlib \
-    system/core/include
+    system/core/include 
 LOCAL_STATIC_LIBRARIES := libziparchive libbase
 LOCAL_SHARED_LIBRARIES := \
     libbinder \
@@ -74,6 +75,9 @@
 
 LOCAL_CFLAGS += -Wall -Werror -Wunused -Wunreachable-code
 
+#log에 대한 lib를 추가합니다.
+LOCAL_LDLIBS := -llog
+
 include $(BUILD_SHARED_LIBRARY)
 
 
diff -urN Android_6.0.1_r11/frameworks/base/libs/androidfw/Asset.cpp SAMD_6.0.1_r11_20170930/frameworks/base/libs/androidfw/Asset.cpp
--- Android_6.0.1_r11/frameworks/base/libs/androidfw/Asset.cpp	2017-09-27 02:07:54.239736042 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/libs/androidfw/Asset.cpp	2017-07-12 02:48:53.460621000 +0900
@@ -38,6 +38,12 @@
 #include <sys/stat.h>
 #include <sys/types.h>
 #include <unistd.h>
+// reviseApp
+#include <android/log.h>
+
+// reviseApp
+#define APPNAME "reviseApp"
+
 
 using namespace android;
 
@@ -70,6 +76,8 @@
             off64_t size = (cur->getLength()+512)/1024;
             char buf[64];
             sprintf(buf, ": %dK\n", (int)size);
+            //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp getAssetSource  : %s" , cur->getAssetSource());
+            //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp size  : %dK" , (int)size);
             res.append(buf);
         }
         cur = cur->mNext;
diff -urN Android_6.0.1_r11/frameworks/base/libs/androidfw/AssetManager.cpp SAMD_6.0.1_r11_20170930/frameworks/base/libs/androidfw/AssetManager.cpp
--- Android_6.0.1_r11/frameworks/base/libs/androidfw/AssetManager.cpp	2017-09-27 02:07:54.239736042 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/libs/androidfw/AssetManager.cpp	2017-07-12 21:27:18.436449000 +0900
@@ -44,6 +44,12 @@
 #include <string.h> // strerror
 #include <strings.h>
 
+// reviseApp
+#include <android/log.h>
+
+// reviseApp
+#define APPNAME "reviseApp"
+
 #ifndef TEMP_FAILURE_RETRY
 /* Used to retry syscalls that can return EINTR. */
 #define TEMP_FAILURE_RETRY(exp) ({         \
@@ -178,6 +184,9 @@
 
 bool AssetManager::addAssetPath(const String8& path, int32_t* cookie)
 {
+
+    //collaboroid resource sharing
+
     AutoMutex _l(mLock);
 
     asset_path ap;
@@ -199,6 +208,9 @@
         }
     }
 
+    //ALOGD("path: %s\nrealpath: %s\nap.path: %s",
+    		//path.string(), realPath.string(), ap.path.string());
+
     // Skip if we have it already.
     for (size_t i=0; i<mAssetPaths.size(); i++) {
         if (mAssetPaths[i].path == ap.path) {
@@ -624,6 +636,9 @@
     Asset* idmap = openIdmapLocked(ap);
     size_t nextEntryIdx = mResources->getTableCount();
     ALOGV("Looking for resource asset in '%s'\n", ap.path.string());
+
+    //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp asset_path!! : %s" , ap.path.string());
+
     if (ap.type != kFileTypeDirectory) {
         if (nextEntryIdx == 0) {
             // The first item is typically the framework resources,
@@ -675,6 +690,8 @@
             openNonAssetInPathLocked("resources.arsc",
                                      Asset::ACCESS_BUFFER,
                                      ap);
+        //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp asset_path!! : %s" , ap.path.string());
+        //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp asset_path!! : %s" , ap.path.string());
         shared = false;
     }
 
@@ -685,6 +702,7 @@
             mResources->add(sharedRes);
         } else {
             ALOGV("Parsing resources for %s", ap.path.string());
+            //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp nextEntryIdx : %zu" , nextEntryIdx+1);
             mResources->add(ass, idmap, nextEntryIdx + 1, !shared);
         }
         onlyEmptyResources = false;
@@ -861,6 +879,8 @@
 {
     Asset* pAsset = NULL;
 
+    //ALOGD("fileName: %s\nap: %s", fileName, ap.path.string());
+
     /* look at the filesystem on disk */
     if (ap.type == kFileTypeDirectory) {
         String8 path(ap.path);
@@ -1133,6 +1153,8 @@
 {
     Asset* pAsset = NULL;
 
+    ALOGD("openAssetFromFileLocked - %s", pathName.string());
+
     if (strcasecmp(pathName.getPathExtension().string(), ".gz") == 0) {
         //printf("TRYING '%s'\n", (const char*) pathName);
         pAsset = Asset::createFromCompressedFile(pathName.string(), mode);
diff -urN Android_6.0.1_r11/frameworks/base/libs/androidfw/ResourceTypes.cpp SAMD_6.0.1_r11_20170930/frameworks/base/libs/androidfw/ResourceTypes.cpp
--- Android_6.0.1_r11/frameworks/base/libs/androidfw/ResourceTypes.cpp	2017-09-27 02:07:54.239736042 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/libs/androidfw/ResourceTypes.cpp	2017-07-12 13:57:02.987709000 +0900
@@ -36,6 +36,11 @@
 #include <utils/Log.h>
 #include <utils/String16.h>
 #include <utils/String8.h>
+// reviseApp
+#include <android/log.h>
+
+// reviseApp
+#define APPNAME "reviseApp"
 
 #ifdef __ANDROID__
 #include <binder/TextOutput.h>
@@ -341,6 +346,9 @@
             // This entry is not present in this idmap
             return BAD_INDEX;
         }
+        //reviseApp
+        //Id get??
+        //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp parsePackage[lookup] : %u", mappedEntry);
         *outEntryId = static_cast<uint16_t>(mappedEntry);
         return NO_ERROR;
     }
@@ -3494,6 +3502,7 @@
     return mTypeSpecFlags;
 }
 
+//reviseApp
 void ResTable::Theme::dumpToLog() const
 {
     ALOGI("Theme %p:\n", this);
@@ -3502,16 +3511,22 @@
         if (pi == NULL) continue;
 
         ALOGI("  Package #0x%02x:\n", (int)(i + 1));
+        __android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "Package : #0x%02x" , (int)(i + 1));
         for (size_t j = 0; j <= Res_MAXTYPE; j++) {
             type_info& ti = pi->types[j];
             if (ti.numEntries == 0) continue;
             ALOGI("    Type #0x%02x:\n", (int)(j + 1));
+            __android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "Type : #0x%02x" , (int)(j + 1));
             for (size_t k = 0; k < ti.numEntries; k++) {
                 const theme_entry& te = ti.entries[k];
                 if (te.value.dataType == Res_value::TYPE_NULL) continue;
                 ALOGI("      0x%08x: t=0x%x, d=0x%08x (block=%d)\n",
                      (int)Res_MAKEID(i, j, k),
                      te.value.dataType, (int)te.value.data, (int)te.stringBlock);
+
+                     __android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "resource=0x%08x t=0x%x, d=0x%08x (block=%d)" ,
+                     (int)Res_MAKEID(i, j, k),
+                                          te.value.dataType, (int)te.value.data, (int)te.stringBlock);
             }
         }
     }
@@ -6093,6 +6108,8 @@
             if (newEntryCount > 0) {
                 uint8_t typeIndex = typeSpec->id - 1;
                 ssize_t idmapIndex = idmapEntries.indexOfKey(typeSpec->id);
+                //reviseApp
+                //this is id??
                 if (idmapIndex >= 0) {
                     typeIndex = idmapEntries[idmapIndex].targetTypeId() - 1;
                 }
@@ -6113,6 +6130,9 @@
                 t->typeSpecFlags = (const uint32_t*)(
                         ((const uint8_t*)typeSpec) + dtohs(typeSpec->header.headerSize));
                 if (idmapIndex >= 0) {
+
+                    //reviseApp
+                    //this is id?
                     t->idmapEntries = idmapEntries[idmapIndex];
                 }
                 typeList.add(t);
@@ -6610,7 +6630,7 @@
 
     return ret;
 }
-
+//reviseApp
 void ResTable::print_value(const Package* pkg, const Res_value& value) const
 {
     if (value.dataType == Res_value::TYPE_NULL) {
@@ -6669,8 +6689,10 @@
     }
 }
 
+//reviseApp
 void ResTable::print(bool inclValues) const
 {
+    __android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp ResTable call");
     if (mError != 0) {
         printf("mError=0x%x (%s)\n", mError, strerror(mError));
     }
@@ -6747,6 +6769,10 @@
                             CHAR16_TO_CSTR(resName.package, resName.packageLen),
                             type8.string(), name8.string(),
                             dtohl(typeConfigs->typeSpecFlags[entryIndex]));
+                            //reviseApp
+                            __android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp  spec resource 0x%08x %s:%s/%s: flags=0x%08x"
+                            , resID,CHAR16_TO_CSTR(resName.package, resName.packageLen),type8.string(), name8.string(),
+                                                          dtohl(typeConfigs->typeSpecFlags[entryIndex]));
                     } else {
                         printf("      INVALID TYPE CONFIG FOR RESOURCE 0x%08x\n", resID);
                     }
@@ -6810,6 +6836,10 @@
                         printf("        resource 0x%08x %s:%s/%s: ", resID,
                                 CHAR16_TO_CSTR(resName.package, resName.packageLen),
                                 type8.string(), name8.string());
+                        __android_log_print(ANDROID_LOG_VERBOSE, APPNAME,
+                        "reviseApp resource 0x%08x %s:%s/%s: "
+                        , resID,CHAR16_TO_CSTR(resName.package, resName.packageLen),
+                        type8.string(), name8.string());
                     } else {
                         printf("        INVALID RESOURCE 0x%08x: ", resID);
                     }
@@ -6855,6 +6885,10 @@
                         printf("t=0x%02x d=0x%08x (s=0x%04x r=0x%02x)",
                                (int)value.dataType, (int)value.data,
                                (int)value.size, (int)value.res0);
+
+                        __android_log_print(ANDROID_LOG_VERBOSE, APPNAME,
+                        "reviseApp t=0x%02x d=0x%08x (s=0x%04x r=0x%02x)"
+                        ,(int)value.dataType, (int)value.data,(int)value.size, (int)value.res0);
                     }
 
                     if ((dtohs(ent->flags)&ResTable_entry::FLAG_PUBLIC) != 0) {
diff -urN Android_6.0.1_r11/frameworks/base/location/java/android/location/ILocationManager.aidl SAMD_6.0.1_r11_20170930/frameworks/base/location/java/android/location/ILocationManager.aidl
--- Android_6.0.1_r11/frameworks/base/location/java/android/location/ILocationManager.aidl	2017-09-27 02:07:54.307736041 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/location/java/android/location/ILocationManager.aidl	2016-11-01 17:36:40.406408000 +0900
@@ -87,6 +87,9 @@
     void setTestProviderStatus(String provider, int status, in Bundle extras, long updateTime,
             String opPackageName);
     void clearTestProviderStatus(String provider, String opPackageName);
+    
+    // ADDED FOR COLLABOROID
+    void setRemoteProviderEnabled(boolean enabled);
 
     boolean sendExtraCommand(String provider, String command, inout Bundle extras);
 
diff -urN Android_6.0.1_r11/frameworks/base/location/java/android/location/LocationManager.java SAMD_6.0.1_r11_20170930/frameworks/base/location/java/android/location/LocationManager.java
--- Android_6.0.1_r11/frameworks/base/location/java/android/location/LocationManager.java	2017-09-27 02:07:54.311736041 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/location/java/android/location/LocationManager.java	2017-01-29 02:51:22.973923000 +0900
@@ -120,6 +120,9 @@
      * @hide
      */
     public static final String FUSED_PROVIDER = "fused";
+    
+    // ADDED FOR COLLABOROID
+    public static final String REMOTE_PROVIDER = "remote";
 
     /**
      * Key used for the Bundle extra holding a boolean indicating whether
diff -urN Android_6.0.1_r11/frameworks/base/preloaded-classes SAMD_6.0.1_r11_20170930/frameworks/base/preloaded-classes
--- Android_6.0.1_r11/frameworks/base/preloaded-classes	2017-09-27 02:07:57.431736001 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/preloaded-classes	2016-11-01 17:36:40.406408000 +0900
@@ -3830,3 +3830,5 @@
 org.xmlpull.v1.XmlPullParserException
 org.xmlpull.v1.XmlSerializer
 sun.misc.Unsafe
+com.android.baksmali.main
+com.android.smali.main
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/services/core/Android.mk SAMD_6.0.1_r11_20170930/frameworks/base/services/core/Android.mk
--- Android_6.0.1_r11/frameworks/base/services/core/Android.mk	2017-09-27 02:07:57.447736001 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/Android.mk	2017-09-07 01:32:21.312307000 +0900
@@ -9,7 +9,7 @@
     java/com/android/server/EventLogTags.logtags \
     java/com/android/server/am/EventLogTags.logtags
 
-LOCAL_JAVA_LIBRARIES := services.net telephony-common
+LOCAL_JAVA_LIBRARIES := libbaksmali libsmali services.net telephony-common
 LOCAL_STATIC_JAVA_LIBRARIES := tzdata_update
 
 include $(BUILD_STATIC_JAVA_LIBRARY)
